// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/ADADIO/ADADIO_Linux_3.x.x.x_GSC_DN/samples/id/perform.c $
// $Rev: 52460 $
// $Date: 2023-01-30 13:52:39 -0600 (Mon, 30 Jan 2023) $

// ADADIO: Sample Application: source file

#include "main.h"



//*****************************************************************************
static void _input_modes(void)
{
	gsc_label("Input Modes");
	printf("Differential, Single Ended, Zero Test, +Vref Test\n");
}



//*****************************************************************************
static void _voltage_ranges(void)
{
	gsc_label("Voltage Ranges");
	printf("+-10V, +-5V, +-2.5V (Factory Configured)\n");
}



//*****************************************************************************
static void _channel_qty(void)
{
	gsc_label("A/D Channels");
	printf("12 Input (simultaneous), 4 Output, 16-bit resolution\n");
}



//*****************************************************************************
static void _clocking_sources(void)
{
	gsc_label("Clocking Sources");
	printf("Internal (Continuous), Software (Burst)\n");
}



//*****************************************************************************
static void _digital_io(void)
{
	gsc_label("Digital I/O");
	printf("8-bit Bidirectional, 1-bit In, 1-bit Out\n");
}



//*****************************************************************************
static int _id_device_brr(const args_t* args)
{
	gsc_reg_def_t	list[2]	= { { NULL }, { NULL } };
	gsc_reg_def_t*	ptr;

	int	errs	= 0;

	printf("\n");
	ptr	= (gsc_reg_def_t*) adadio_reg_get_def_id(ADADIO_GSC_BRR);

	if (ptr)
	{
		list[0]	= ptr[0];
		errs	= gsc_reg_list(args->fd, list, 1, adadio_reg_read);
	}
	else
	{
		errs++;
		printf(	"FAIL <---  (%d. adadio_reg_get_def_id, ADADIO_GSC_BRR)\n",
				__LINE__);
	}

	return(errs);
}



//*****************************************************************************
static int _register_map(const args_t* args)
{
	int	errs;

	printf("\n");
	errs	= adadio_reg_list(args->fd, args->detail);
	return(errs);
}



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;
	int	i;

	gsc_label("Device Features");
	printf("\n");

	gsc_label_level_inc();

	_input_modes();
	_voltage_ranges();
	_channel_qty();
	_clocking_sources();
	_digital_io();

	for (i = 0; i < ADADIO_QUERY_LAST; i++)
		errs	+= adadio_query(args->fd, -1, 1, i, NULL);

	gsc_label_level_dec();

	errs	+= _id_device_brr(args);
	errs	+= _register_map(args);

	return(errs);
}


