// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/ADADIO/ADADIO_Linux_3.x.x.x_GSC_DN/utils/util_ain_nrate.c $
// $Rev: 44402 $
// $Date: 2019-02-06 13:38:11 -0600 (Wed, 06 Feb 2019) $

// ADADIO: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	adadio_ain_nrate
*
*	Purpose:
*
*		Provide a visual wrapper for the ADADIO_IOCTL_AIN_NRATE service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		set		The setting to apply.
*
*		get		The current setting is recorded here, if not NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int adadio_ain_nrate(int fd, int index, int verbose, s32 set, s32* get)
{
	int		errs;
	int		ret;
	long	sps;

	if (verbose)
		gsc_label_index("Input Nrate", index);

	ret		= adadio_ioctl(fd, ADADIO_IOCTL_AIN_NRATE, &set);
	errs	= ret ? 1 : 0;

	if (set < 1)
		sps	= 20000000L / 1;
	else if (set > 0xFFFF)
		sps	= 20000000L / 0xFFFF;
	else
		sps	= 20000000L / set;

	if (verbose)
	{
		printf("%s  (", errs ? "FAIL <---" : "PASS");
		gsc_label_long_comma(set);
		printf(", ");
		gsc_label_long_comma(sps);
		printf(" S/S)\n");
	}

	if (get)
		get[0]	= set;

	return(errs);
}


