// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/ADADIO/ADADIO_Linux_3.x.x.x_GSC_DN/utils/util_dio_pin_write.c $
// $Rev: 44402 $
// $Date: 2019-02-06 13:38:11 -0600 (Wed, 06 Feb 2019) $

// ADADIO: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	adadio_dio_pin_write
*
*	Purpose:
*
*		Provide a visual wrapper for the ADADIO_IOCTL_DIO_PIN_WRITE service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		set		The setting to apply.
*
*		get		The current setting is recorded here, if not NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int	adadio_dio_pin_write(int fd, int index, int verbose, s32 set, s32* get)
{
	char	buf[64];
	int		errs;
	int		ret;

	if (verbose)
		gsc_label_index("DIO Pin Write", index);

	ret		= adadio_ioctl(fd, ADADIO_IOCTL_DIO_PIN_WRITE, &set);
	errs	= ret ? 1 : 0;

	switch (set)
	{
		default:

			errs++;
			sprintf(buf, "INVALID: %ld", (long) set);
			break;

		case ADADIO_DIO_PIN_CLEAR:

			strcpy(buf, "0, clear");
			break;

		case ADADIO_DIO_PIN_SET:

			strcpy(buf, "1, set");
			break;
	}

	if (verbose)
		printf("%s  (%s)\n", errs ? "FAIL <---" : "PASS", buf);

	if (get)
		get[0]	= set;

	return(errs);
}


