// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/ADADIO/ADADIO_Linux_3.x.x.x_GSC_DN/utils/util_dio_port_read.c $
// $Rev: 44402 $
// $Date: 2019-02-06 13:38:11 -0600 (Wed, 06 Feb 2019) $

// ADADIO: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	adadio_dio_port_read
*
*	Purpose:
*
*		Provide a visual wrapper for the ADADIO_IOCTL_DIO_PORT_READ service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		get		The current setting is recorded here, if not NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int	adadio_dio_port_read(int fd, int index, int verbose, s32* get)
{
	int	errs;
	int	ret;
	s32	set;

	if (verbose)
		gsc_label_index("DIO Port Read", index);

	ret		= adadio_ioctl(fd, ADADIO_IOCTL_DIO_PORT_READ, &set);
	errs	= ret ? 1 : 0;

	if (verbose)
		printf("%s  (0x%02lX)\n", errs ? "FAIL <---" : "PASS", (long) set);

	if (get)
		get[0]	= set;

	return(errs);
}


